
using DLL_library;

namespace TestDLL.text
{
    [TestClass]
    public class UnitTest1
    {
        /// <summary>
        ///     VIS
        /// </summary>
        [TestMethod]
        public void TestMethod_CheckControlSum_VIS_ControlSum()
        {
            //WAUYP6AAAAA141245
            Task_dll task_Dll = new Task_dll("WAUYP6401N1412456");
            bool check = task_Dll.CheckControlSum();
            Assert.IsTrue(check);
        }
        /// <summary>
        ///   ,     char
        /// </summary>
        [TestMethod]
        public void TestMethod_Input_Array_VIS_ArraySymbol()
        {
            Task_dll task_Dll = new Task_dll("WAUYP6401N1412456");
            bool check = task_Dll.CheckControlSum();
            char[] arraySim = task_Dll.Input_Array();    
            Assert.IsInstanceOfType(arraySim, typeof(char[]));
        }
        /// <summary>
        ///   ,   VIS  17
        /// </summary>
        [TestMethod]
        public void TestMethod_Input_Array_VIS_Count()
        {
            Task_dll task_Dll = new Task_dll("WAUYP6401N1412456");
            Assert.AreEqual(17, task_Dll.VIS.Length);
        }
        /// <summary>
        ///   ,       char
        /// </summary>
        [TestMethod]
        public void TestMethod_Input_Array_ArraySymol_Input()
        {
            Task_dll task_Dll = new Task_dll("WAUYP6401N1412456");
            char[] arraySim = task_Dll.Input_Array();
            for (int i = 0; i < arraySim.Length; i++)
            {
                Assert.IsInstanceOfType(arraySim[i], typeof(char)); 
            }
            
        }
        /// <summary>
        ///   ,        int
        /// </summary>
        [TestMethod]
        public void TestMethod_Input_Array_ArraySymol_NotInput()
        {
            Task_dll task_Dll = new Task_dll("WAUYP6401N1412456");
            char[] arraySim = task_Dll.Input_Array();
            for (int i = 0; i < arraySim.Length; i++)
            {
                Assert.IsNotInstanceOfType(arraySim[i], typeof(int));
            }
        }
        /// <summary>
        ///   ,         Null
        /// </summary>
        [TestMethod]
        public void TestMethod_CountSum_Output_Result()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            task.CheckControlSum();
            string result = task.CountSum();
            Assert.IsNotNull(result);
        }
        /// <summary>
        ///   ,      
        /// </summary>
        [TestMethod]
        public void TestMethod_CountSum_Output_ResultNotInt()
        {
            bool check = false;
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            task.CheckControlSum();
            string result = task.CountSum();
            for (int i = 0; i < result.Length; i++)
            {
                try
                {
                    string opa = Convert.ToString(result[i]);
                    double res = Convert.ToDouble(opa);
                    check = true;

                }
                catch
                {
                    if (check)
                    {
                        Assert.Fail("    ");
                    }
                    else continue;
                }
            }
        }
        /// <summary>
        ///   ,   VIS  I O Q
        /// </summary>
        [TestMethod]
        public void TestMethod_CheckVISAllNotSymbol_VIS_NotInSymbol()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            bool result = task.CheckVISAllNotSymbol();
            Assert.AreEqual(true, result);
        }
        /// <summary>
        ///   ,         
        /// </summary>
        [TestMethod]
        public void TestMethod_Input_Array_ElementsArray_Symbol()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            char[] arraySym = task.Input_Array();
            int numChar = 65;
            for (int i = 0;i < arraySym.Length;i++)
            {
                if (numChar == 73 || numChar == 79 || numChar == 81) numChar++; 
                else if ((int)arraySym[i] != numChar)
                {
                    Assert.Fail("       ");
                }
                numChar++;
            }
        }
        /// <summary>
        ///   ,       VIS
        /// </summary>
        [TestMethod]
        public void TestMethod_workWithVIS_VIS_NumEcvivalent()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");

            int[] numEcvavilent = task.workWithVIS();
            Assert.AreEqual(task.VIS.Length, numEcvavilent.Length);
        }
        /// <summary>
        ///   ,     VIS  Null
        /// </summary>
        [TestMethod]
        public void TestMethod_Task_dll_VIS_ElementsVIS()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            Assert.IsNotNull(task.VIS);
        }
        /// <summary>
        ///   ,        10
        /// </summary>
        [TestMethod]
        public void TestMethod_Task_dll_valuesAsArray_ElementsvaluesAsArray()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            for (int i = 0; i < task.valuesAsArray.Length; i++)
            {
                if (task.valuesAsArray[i] > 10)
                {
                    Assert.Fail("     10");
                }
            }
        }
        /// <summary>
        ///   ,          -1
        /// </summary>
        [TestMethod]
        public void TestMethod_Task_dll_weightNum_ElementsvaluesAsArray()
        {
            Task_dll task = new Task_dll("WAUYP6401N1412456");
            if (task.weightNum[8] != -1)
            {
                Assert.Fail("       ");
            }
        }
        /// <summary>
        ///   ,      
        /// </summary>
        [TestMethod]
        public void TestMethod_CountSum_ontrolSum_resultSum()
        {
            Task_dll task = new Task_dll("JHMCM56557C404453");
            task.CheckControlSum();
            Assert.AreEqual(368, task.controlSum);
        }
        /// <summary>
        ///   ,        
        /// </summary>
        [TestMethod]
        public void TestMethod_CountSum_raznSum_resultRaznSum()
        {
            Task_dll task = new Task_dll("JHMCM56557C404453");
            task.CheckControlSum();
            Assert.AreEqual(5, task.raznSum);
        }
    }
}
